#****************************************************************************
#**
#**  File     :  /lua/defaultunits.lua
#**  Author(s):  John Comes, Gordon Duclos
#**
#**  Summary  :  Default definitions of units
#**
#**  Copyright  2005 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************


#-------------------------------------------------------------
#  ENERGY CREATION UNITS
#-------------------------------------------------------------
local oldEnergyCreationUnit = EnergyCreationUnit
EnergyCreationUnit = Class(oldEnergyCreationUnit) {
	
	OnStopBeingBuilt = function(self,builder,layer)
		self:ForkThread(self.PowerplantXP)
		oldEnergyCreationUnit.OnStopBeingBuilt(self,builder,layer)
	end,
	
	
	PowerplantXP = function(self)
		WaitSeconds(6)
	    while not self:IsDead() do 
	    	self:AddXP(self.XPnextLevel/100)	
			WaitSeconds(6)
	    end
    end,
	    
}

local oldRadarUnit = RadarUnit
RadarUnit = Class(oldRadarUnit) {
    
    OnIntelDisabled = function(self)
        oldRadarUnit.OnIntelDisabled(self)
        KillThread(self.RadarXPThread)
    end,

    OnIntelEnabled = function(self)
        oldRadarUnit.OnIntelEnabled(self)
        self.RadarXPThread = ForkThread(self.RadarXP, self)
    end,
    
    RadarXP = function(self)
		WaitSeconds(3)
	    while not self:IsDead() do 
	    	self:AddXP(self.XPnextLevel/100)	
			WaitSeconds(3)
	    end
    end,
}
